unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Tabs, StdCtrls, DB, DBTables, Dbtabset, Grids, DBGrids,
  ExtCtrls, Mask, DBCtrls, TabNotBk, Buttons, About;

type
  ETableNotFound = class(Exception);

  TForm1 = class(TForm)
    tblsrcEmployees: TDataSource;
    tblEmployees: TTable;
    TabbedNotebook1: TTabbedNotebook;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    DBTabSet1: TDBTabSet;
    pnlSpeedBar: TPanel;
    btnspdAbout: TSpeedButton;
    btnspdHelp: TSpeedButton;
    Memo1: TMemo;
    tblCustomers: TTable;
    tblsrcCustomers: TDataSource;
    DBTabSet2: TDBTabSet;
    tblOrders: TTable;
    tblsrcOrders: TDataSource;
    tblOrdersTerms: TStringField;
    tblOrdersPaymentMethod: TStringField;
    tblOrdersItemsTotal: TCurrencyField;
    tblOrdersAmountPaid: TCurrencyField;
    tblOrdersCustNo: TFloatField;
    tblOrdersOrderNo: TFloatField;
    Panel3: TPanel;
    DBGrid2: TDBGrid;
    Panel5: TPanel;
    DBTabSet3: TDBTabSet;
    Edit2: TEdit;
    Label8: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EditEmpNo: TDBEdit;
    EditLastName: TDBEdit;
    EditFirstName: TDBEdit;
    EditPhoneExt: TDBEdit;
    DBGrid3: TDBGrid;
    tblCustomersCompany: TStringField;
    tblCustomersCustNo: TFloatField;
    tblCustomersContact: TStringField;
    RadioGroup1: TRadioGroup;
    tblEmployeesEmpNo: TIntegerField;
    tblEmployeesLastName: TStringField;
    tblEmployeesFirstName: TStringField;
    tblEmployeesPhoneExt: TStringField;
    tblEmployeesSalary: TFloatField;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure tblsrcEmployeesDataChange(Sender: TObject; Field: TField);
    function GetDatabaseName: string;
    procedure Edit1Change(Sender: TObject);
    procedure DBTabSet2Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure tblsrcCustomersDataChange(Sender: TObject; Field: TField);
    procedure tblsrcOrdersDataChange(Sender: TObject; Field: TField);
    procedure btnspdAboutClick(Sender: TObject);
    procedure DBTabSet2LoadFromDataSet(Sender: TObject;
      var Accept: Boolean; var TabField: OpenString);
    procedure RadioGroup1Click(Sender: TObject);
    procedure tblsrcEmployeesUpdateData(Sender: TObject);
    procedure btnspdHelpClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{-------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  { the following code is present to set up the demo - it
    is not related to the use of TDBTabSet }
  Application.HelpFile      := 'DBTABSET.HLP';
  Application.OnHint        := ShowHint;
  Application.ShowHint      := false;
  tblEmployees.DatabaseName := GetDatabaseName;
  tblCustomers.DatabaseName := tblEmployees.DatabaseName;
  tblOrders.DatabaseName    := tblEmployees.DatabaseName;
  if not FileExists(tblEmployees.DatabaseName + '\' + tblEmployees.TableName) then
    raise ETableNotFound.Create('Employees table cannot be located');
  if not FileExists(tblCustomers.DatabaseName + '\' + tblCustomers.TableName) then
    raise ETableNotFound.Create('Customers table cannot be located');
  if not FileExists(tblOrders.DatabaseName + '\' + tblOrders.TableName) then
    raise ETableNotFound.Create('Customers table cannot be located');
  tblEmployees.Open;
  tblCustomers.Open;
  tblOrders.Open;

  { the following method calls to LoadFromDataSet loads the dataset
    data into each of the three demo TDBTabSets }
  DBTabSet1.LoadFromDataSet;
  DBTabSet2.LoadFromDataSet;
  DBTabSet3.LoadFromDataSet;
end;

{-------------------------------------------------}
procedure TForm1.ShowHint(Sender: TObject);
begin
  { this code supports the demo }
  Memo1.Clear;
  Memo1.Lines[0] := Application.Hint;
end;

{-------------------------------------------------}
procedure TForm1.btnspdHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

{-------------------------------------------------}
procedure TForm1.tblsrcEmployeesDataChange(Sender: TObject; Field: TField);
begin
  { SynchTabSet is the method used to synchronize the DBTabSet's selected
    tab to the currently selected dataset record }
  DBTabSet1.SynchTabSet;
end;

{-------------------------------------------------}
procedure TForm1.tblsrcCustomersDataChange(Sender: TObject; Field: TField);
begin
  { SynchTabSet is the method used to synchronize the DBTabSet's selected
    tab to the currently selected dataset record }
  DBTabSet2.SynchTabSet;
end;

{-------------------------------------------------}
procedure TForm1.tblsrcOrdersDataChange(Sender: TObject; Field: TField);
begin
  { SynchTabSet is the method used to synchronize the DBTabSet's selected
    tab to the currently selected dataset record }
  DBTabSet3.SynchTabSet;
end;

{-------------------------------------------------}
procedure TForm1.tblsrcEmployeesUpdateData(Sender: TObject);
begin
  { reload the tabs if record added/deleted/changed }
  DBTabSet1.Tabs.Clear;
  DBTabSet1.LoadFromDataSet;
end;

{-------------------------------------------------}
procedure TForm1.Edit1Change(Sender: TObject);
begin
  { This is the incremental search field for the employee demo.
    Because of the code in TForm1.tblsrcEmployeesDataChange,
    the movement of the record pointer caused by this FindNearest
    will also move the selected tab in the DBTabSet }
  tblEmployees.FindNearest([Edit1.Text]);
end;

{-------------------------------------------------}
procedure TForm1.Edit2Change(Sender: TObject);
begin
  { This is the incremental search field for the Header - Detail demo.
    Because of the code in TForm1.tblsrcCustomersDataChange,
    the movement of the record pointer caused by this FindNearest
    will also move the selected tab in the DBTabSet }
  tblCustomers.FindNearest([Edit2.Text]);
end;

{-------------------------------------------------}
procedure TForm1.DBTabSet2Click(Sender: TObject);
begin
  { When the selected tab representing Customer in the Header-Detail
    example is clicked, the DBTabSet representing the orders for
    the customer is reloaded. Note that LoadFromDataSet does not
    automatically clear the DBTabSet -- you must clear it yourself }
  DBTabSet3.Tabs.Clear;
  DBTabSet3.LoadFromDataSet;
end;

{-------------------------------------------------}
procedure TForm1.btnspdAboutClick(Sender: TObject);
begin
  { Maelstrom AboutBox }
  frmAboutBox.ShowModal;
end;

{-------------------------------------------------}
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  { the Filter example for the OnLoadFromDataSet event filters the tabs
    loaded, not the dataset.  Normally, you'd probably filter the dataset,
    but this gives a good example of how OnLoadFromDataSet works }
  DBTabSet2.Tabs.Clear;
  DBTabSet2.LoadFromDataSet;
  { initiate reload of Orders into DBTabSet3 }
  DBTabSet2.Click;
end;

{-------------------------------------------------}
procedure TForm1.DBTabSet2LoadFromDataSet(Sender: TObject;
  var Accept: Boolean; var TabField: OpenString);
var
  AlphaFilter: string;
begin
  { example of how the OnLoadFromDataSet event can be used to filter
    the tabs }
  if RadioGroup1.ItemIndex = 26 then AlphaFilter := 'Z';
  if RadioGroup1.ItemIndex = 25 then AlphaFilter := 'Y';
  if RadioGroup1.ItemIndex = 24 then AlphaFilter := 'X';
  if RadioGroup1.ItemIndex = 23 then AlphaFilter := 'W';
  if RadioGroup1.ItemIndex = 22 then AlphaFilter := 'V';
  if RadioGroup1.ItemIndex = 21 then AlphaFilter := 'U';
  if RadioGroup1.ItemIndex = 20 then AlphaFilter := 'T';
  if RadioGroup1.ItemIndex = 19 then AlphaFilter := 'S';
  if RadioGroup1.ItemIndex = 18 then AlphaFilter := 'R';
  if RadioGroup1.ItemIndex = 17 then AlphaFilter := 'Q';
  if RadioGroup1.ItemIndex = 16 then AlphaFilter := 'P';
  if RadioGroup1.ItemIndex = 15 then AlphaFilter := 'O';
  if RadioGroup1.ItemIndex = 14 then AlphaFilter := 'N';
  if RadioGroup1.ItemIndex = 13 then AlphaFilter := 'M';
  if RadioGroup1.ItemIndex = 12 then AlphaFilter := 'L';
  if RadioGroup1.ItemIndex = 11 then AlphaFilter := 'K';
  if RadioGroup1.ItemIndex = 10 then AlphaFilter := 'J';
  if RadioGroup1.ItemIndex = 9 then AlphaFilter := 'I';
  if RadioGroup1.ItemIndex = 8 then AlphaFilter := 'H';
  if RadioGroup1.ItemIndex = 7 then AlphaFilter := 'G';
  if RadioGroup1.ItemIndex = 6 then AlphaFilter := 'F';
  if RadioGroup1.ItemIndex = 5 then AlphaFilter := 'E';
  if RadioGroup1.ItemIndex = 4 then AlphaFilter := 'D';
  if RadioGroup1.ItemIndex = 3 then AlphaFilter := 'C';
  if RadioGroup1.ItemIndex = 2 then AlphaFilter := 'B';
  if RadioGroup1.ItemIndex = 1 then AlphaFilter := 'A';
  if RadioGroup1.ItemIndex = 0 then AlphaFilter := '';
  if RadioGroup1.ItemIndex = -1 then AlphaFilter := '';
  if AlphaFilter = '' then Accept := true
  else if copy(tblCustomers.FieldByName('Company').AsString, 1, 1) <> AlphaFilter then
      Accept := False;
end;

{-------------------------------------------------}
{used by demo to build database name -- not related to TDBOutline}
function TForm1.GetDatabaseName: string;
var
  ExeDirName,
  ExeFileName: array[0..100] of Char;
  FileNamePtr: PChar;
  NumChars: Word;
begin
  StrPCopy(ExeFileName, Application.ExeName);
  FileNamePtr := StrRScan(ExeFileName, '\');
  NumChars := FileNamePtr - ExeFileName;
  StrLCopy(ExeDirName, ExeFileName, NumChars);
  Result := StrPas(ExeDirName);
end;


end.
